<?php
 


class Limex_Advr_Block_Adminhtml_Order_Customer extends Limex_Advr_Block_Adminhtml_Order_Abstract
{
    public function _prepareLayout()
    {
        parent::_prepareLayout();
        
        $this->setHeaderText(Mage::helper('advr')->__('Sales By Customer'));

        return $this;
    }

    protected function _prepareChart()
    {
        return $this;
    }

    protected function _prepareGrid()
    {
        $this->_initGrid()
            ->setDefaultSort('sum_grand_total')
            ->setDefaultDir('desc')
            ->setRowUrlCallback(array($this, 'rowUrlCallback'))
            ;

        return $this;
    }

    protected function _prepareCollection()
    {
        $collection = Mage::getModel('advr/report_sales')
            ->setBaseTable('sales/order')
            ->setFilterData($this->getFilterData())
            ->selectColumns(array_merge(
                array('customer_id'),
                $this->getVisibleColumns())
            )
            ->addFieldToFilter('customer_group_id', array('gt' => 0))
            ->groupByColumn('customer_id')
            ;

        return $collection;
    }

    public function getColumns()
    {
        $groups = Mage::getResourceModel('customer/group_collection')
            ->addFieldToFilter('customer_group_id', array('gt' => 0))
            ->load()
            ->toOptionHash();

        $columns = array(
            'customer_email' => array(
                'header'                => 'Customer',
                'totals_label'          => 'Total',
                'filter_totals_label'   => 'Subtotal',
                'frame_callback'        => array(Mage::helper('advr/callback'), 'linkToCustomer'),
                'chart'                 => true,
            ),

            'customer_name' => array(
                'header'                => 'Customer Name',
                'filter'                => false,
            ),

            'customer_group_id' => array(
                'header'               => 'Customer Group',
                'chart'                => false,
                'type'                 => 'options',
                'options'              => Mage::getSingleton('advr/system_config_source_customerGroup')->toOptionHash(),
            ),

        );

        $columns += $this->getOrderTableColumns(true);

        return $columns;
    }

    public function rowUrlCallback($row)
    {
        if ($row->getCustomerId()) {
            return $this->getUrl('adminhtml/customer/edit', array('id' => $row->getCustomerId()));
        }

        return false;
    }
}